--geiles game by knorke
local player_a = 0

ship_radius = 10
ship_acc = 50
ship_turnrate = 5
bullet_speed = 100
bullet_radius = 4
rock_speed = 1

ship_max_energy = 100
ship_energy_per_shot = 25
ship_energy = 0
ship_energy_recharge = 50 

local large_rock_radius = 60
local medium_rock_radius = 30
local small_rock_radius = 15
local points = 0
local lives = 3
local level = 0

local res_w = 800
res_h = 600
local show_debug = false
  
local sin = math.sin
local cos = math.cos
local random = math.random
local bullets = {}
local rocks = {}
local sound_laser = nil


local game_status --MENU  RESPAWN  INGAME GAMEOVER

shield_max_power = 100
shield_power = shield_max_power
shield_drain = 40
font = love.graphics.newFont( 1.0 )

function love.load()
world = love.physics.newWorld(800, 600) --create a world for the bodies to exist in
world:setGravity(0, 0)
world:setMeter(64) --the height of a meter in this world will be 64px
player = love.physics.newBody(world, 100, 100, 10, 5)
player:setBullet (true) --I MUST BECOME THE BULLET
love.graphics.setMode(res_w, res_h)
ship_energy = ship_max_energy
sound_laser = love.audio.newSource("laser.wav", "static")
--data = love.sound.newSoundData("laser.wav")
--sound_laser = love.audio.newSource(data)
game_status = "MENU"
love.graphics.setColor(0, 255, 150, 255)
love.graphics.setLine(3)
end


function new_game ()
player:setPosition (res_w/2,res_h/2)
player:setLinearVelocity (0,0)
player_a = 0
points = 0
lives = 3
rocks = {}
bullets = {}
shield_power = shield_max_power --the power is maximum!
game_status = "INGAME"
level = 1
end

function new_ship ()
player:setPosition (res_w/2,res_h/2)
player:setLinearVelocity (0,0)
player_a = 0
lives = lives -1
shield_power = shield_max_power
game_status = "INGAME"
end

function love.draw()
if (game_status == "MENU" or game_status == "GAMEOVER") then
love.graphics.print("Astropatrolonium!", res_w/2-200+random(0,5), res_h/4+random(0,5), 0, 3,3)
	love.graphics.print("press n for a new game", res_w/2-200, res_h/4+100, 0, 1,1)
	love.graphics.print("left, right arrow keys to steer. up key to thrust. space to shoot.", res_w/2-200, res_h/4+120, 0, 1,1)
	if (game_status == "GAMEOVER") then
		love.graphics.print("your score: " .. points .. " points!", res_w/2, res_h/4+50, 0, 2,2)
		end
	end

if (game_status == "RESPAWN") then
love.graphics.print("press shot to respawn", res_w/2-200, res_h/4+random(0,5), 0, 3,3)	
	end		

	if (show_debug == true) then
		font:setLineHeight (1.0)
		love.graphics.print(player:getX(), 10, 10)
		love.graphics.print(player:getY(), 10, 20)
		love.graphics.print("bullets:" .. #bullets, 200, 200)
		love.graphics.print("rocks:" .. #rocks, 200, 210)
		love.graphics.print("Energy:" .. ship_energy, 10, 30)
		love.graphics.print("Shield:" .. shield_power, 10, 40)	
		love.graphics.print("game_status:" .. game_status, 10, 50)	
		love.graphics.print("level:" ..level, 10, 60)	
		love.graphics.print("press d to toggle this debug info", 10, 80)	
		end
if (game_status == "INGAME" or game_status =="RESPAWN" ) then
	love.graphics.print("Points:" .. points, res_w-300, 40,0,3,3)
	--live display
	if (lives > 0) then
		love.graphics.print("Ships:", 10, res_h-40,0,3,3)	
		for bla = 1, lives, 1 do
			draw_ship (110+bla*ship_radius*1.5, res_h-50,0)
			end
		end
	if (shield_power > 1) then
		love.graphics.print("Level:" ..level-1 .. " get ready!" , res_w/2-200, res_h/2-50, 0, 3,3)	
		end
	draw_bullets ()
	draw_rocks ()
	end
if (game_status == "INGAME") then draw_ship (player:getX(), player:getY(), player_a, shield_power) end
end

function collision()
if (player:getX() < -ship_radius/2) then player:setX (res_w+ship_radius/2) end
if (player:getX() > res_w+ship_radius/2) then player:setX (-ship_radius/2) end
if (player:getY() < -ship_radius/2) then player:setY (res_h+ship_radius/2) end
if (player:getY() > res_h+ship_radius/2) then player:setY (-ship_radius/2) end

for u,r in ipairs(rocks) do	
	local rx = r.b:getX()
	local ry = r.b:getY()
	local rr = r.s:getRadius()		
	if (rx < -rr) then rx = res_w+rr end
	if (rx > res_w+rr) then rx = -rr end
	if (ry < -rr) then ry = res_h+rr end
	if (ry > res_h+rr) then ry = -rr end
	r.b:setPosition (rx,ry)
	for i,v in ipairs(bullets) do
		if (is_offscreen (v:getX(), v:getY()) == true) then table.remove(bullets, i) end --remove bullets outside of screen	
				
		local distance = math.abs (rx - v:getX())  + math.abs (ry - v:getY()) 
		if (distance < rr) then
			points = points + r.size*15
			local new_size = r.size - 1
			if (new_size == 1) then
				add_rock (1, r.b:getX(), r.b:getY())
				add_rock (1, r.b:getX(), r.b:getY())
				end
			if (new_size == 2) then
				add_rock (2, r.b:getX(), r.b:getY())
				add_rock (2, r.b:getX(), r.b:getY())
				end
			
			table.remove (rocks, u)
			table.remove(bullets, i)
			
			end		
		end
	if (shield_power < 1) then --unverwundbar
		player_dist = math.abs (rx - player:getX())  + math.abs (ry - player:getY()) 
		if (player_dist < rr) then 
			if (lives > 0) then game_status = "RESPAWN" end
			if (lives == 0) then game_status = "GAMEOVER" end
			end
	end
	end
end


function is_offscreen (x,y)
if (x < 0) then return true end
if (y < 0) then return true end 
if (x > res_w) then return true end 
if (y > res_h) then return true end
return false
end

function is_far_offscreen (x,y)
if (x < -res_w/2) then return true end
if (y < -res/2) then return true end 
if (x > res_w*1.5) then return true end 
if (y > res_h*1.5) then return true end
return false
end



function love.update(dt)
if (game_status == "INGAME") then 
	if love.keyboard.isDown("left") then player_a=player_a+(ship_turnrate*dt) end
	if love.keyboard.isDown("right") then player_a=player_a-(ship_turnrate*dt) end
		if love.keyboard.isDown("up") then 
		local fx = -sin(player_a) *  ship_acc
		local fy = -cos(player_a) *  ship_acc
		player:applyForce (fx,fy)
		end	
		if love.keyboard.isDown("r") then  
		player:setX(res_w/2)
		player:setY(res_h/2)
		end
	if (ship_energy < ship_max_energy) then ship_energy = ship_energy + ship_energy_recharge * dt end
	if (shield_power > 0) then shield_power = shield_power - shield_drain * dt end
	collision ()
	if (#rocks == 0) then new_level () end
	end
world:update(dt)
	--if (sound_laser:isStopped() == true) then  love.audio.rewind (sound_laser) end
end

function love.keypressed(key, unicode)
if (key=='d') then
	if (show_debug==true) then show_debug = false else show_debug = true end
	end
if (key=='a') then add_rock (3) end
if (key == " " and game_status == "INGAME") then  shoot_bullet () end
if (key == " " and game_status == "RESPAWN") then  new_ship () end
if (key == "n" and (game_status == "MENU" or game_status=="GAMEOVER")) then  new_game () end
end

function shoot_bullet ()
if (ship_energy < ship_energy_per_shot or shield_power > 1) then return end
--love.audio.play(sound_laser)
ship_energy = ship_energy - ship_energy_per_shot
local x = player:getX()
local y = player:getY()
b = love.physics.newBody(world, x, y,10,5)
b:setBullet (true)
b:applyImpulse (-sin(player_a) *  bullet_speed, -cos(player_a) *  bullet_speed)
table.insert(bullets, b)
end
   

function draw_ship (x,y, a, shield)
love.graphics.setColor(0, 255, 150, 255)
love.graphics.setLine(3)
local p1x = (x-sin(a)*10) -- obere Spitze
local p1y=(y-cos(a)*10)
   local p2x= (x+sin(a)*ship_radius/2)--unteres Ende
   local p2y=(y+cos(a)*ship_radius/2)
local p3x= (x+sin(a-0.8)*ship_radius)--- linke Flgelspitze
local p3y= (y+cos(a-0.8)*ship_radius)
   local p4x= (x+sin(a+0.8)*ship_radius)-- rechte Flgelspitze
   local p4y= (y+cos(a+0.8)*ship_radius)
love.graphics.line (p1x,p1y, p4x,p4y)
love.graphics.line (p1x,p1y, p3x,p3y)
love.graphics.line (p4x,p4y, p2x,p2y)
love.graphics.line (p3x,p3y, p2x,p2y)
--love.graphics.circle ("line",x,y, 5,5)
 if (shield ~= nil) then
	if (shield > 1) then 
	love.graphics.circle ("line",x,y, ship_radius*2,16)
	end	
	end
 end
 
 function draw_bullets ()
 for i,v in ipairs(bullets) do
	love.graphics.circle ("fill", v:getX(), v:getY(), bullet_radius, 8)
	end
 end

 
function add_rock (size, x,y)
if (x==nil) then x = random (0, res_w) end
if (y==nil) then y = random (-500, -200) end
local b = {}
local nr = 5
if (size == 3) then nr = large_rock_radius end
if (size == 2) then nr = medium_rock_radius end
if (size == 1) then nr = small_rock_radius end

b.b = love.physics.newBody(world, x, y, nr,5)
b.s = love.physics.newCircleShape(b.b, nr)
b.size = size
if (size == 1) then b.b:applyImpulse (random (-90,90), random (-90,-90))
else b.b:applyImpulse (random (-50,50), random (-50,-50))
end
table.insert(rocks, b)
end


function new_level ()
if (level == 1) then add_rock (3) end
if (level == 2) then 
	add_rock (3)
	add_rock (2)
	end
if (level == 3) then 
	add_rock (3)
	add_rock (2)
	add_rock (1) 
	end	
if (level > 3) then
	for blabla = 0, level*2, 1 do
		add_rock (math.random(1,3))
		end
	end
points = points + 100
shield_power = shield_max_power
level = level + 1
end

 
 function draw_rocks ()
 for i,v in ipairs(rocks) do
	love.graphics.circle ("line", v.b:getX(), v.b:getY(), v.s:getRadius(), 32)
	if (show_debug==true) then 	
		font:setLineHeight (1.0)
		love.graphics.print(math.floor(v.b:getX())..":".. math.floor(v.b:getY()) , v.b:getX(), v.b:getY()) 
	end
	end
 end